progname=exercise_03_12

CPP_FILES=$(wildcard *.cpp)
TEST_INPUT_FILES=$(wildcard test*.in)

O_FILES=$(patsubst  %.cpp, %.o,  $(CPP_FILES))
S_FILES=$(patsubst  %.cpp, %.s,  $(CPP_FILES))
II_FILES=$(patsubst %.cpp, %.ii, $(CPP_FILES))
TEST_TARGETS=$(patsubst %.in, %, $(TEST_INPUT_FILES))

$(progname): $(O_FILES) | .gitignore
	g++ $^ -o $@

%.o: %.s
	g++ -c $^ -o $@

%.s: %.ii
	g++ -S $^ -o $@

%.ii: %.cpp
	g++ -E $< -o $@

exercise_03_12.ii Account.ii: Account.hpp

.PRECIOUS: $(S_FILES) $(II_FILES)
.SECONDARY: $(S_FILES) $(II_FILES)

.gitignore:
	echo $(progname) > $@

clean:
	rm *.ii *.s *.o $(progname) *.out .gitignore

test: $(TEST_TARGETS)
	echo "All tests passed successfully."

test%: $(progname)
	echo "Testing $@..."
	./$(progname) < $@.in > $@.out || echo "$(progname) returned non-zero"
	diff $@.out $@.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

